function [optValue,bestP,endNFEs]=CMAES(fType,pType,Max_NFEs,NP)
    addpath('../');
    [UB,LB,Dim] = Parameter(pType); % UBΪϽ磺1*DimLBΪ½磺1*Dim
    
    index = fType; % Ժ
    
    optValue = [];

    %% ʼ
    N = Dim;
    maxeval = Max_NFEs;
    xmeanw = (LB + rand.*(UB - LB))'; %ʼֵ
    sigma=0.25; %ʼ(׼) sigma
    minsigma=1e-15;
    maxsigma=max(UB-LB)/sqrt(Dim);
    flginiphase=1; %ʼ׶
    OFV = [];
    %% еĲ
    % ѡ
    lambda = 4+floor(3*log(Dim)); % 
    mu = floor(lambda/2); %ĸĿ
    arweights = log((lambda + 1)/2) - log(1:mu)'; % *1 飨Ȩأ
        
    % parameter setting: adaptation
    cc = 4/(N + 4); %·ۻ
    ccov = 2/(N + 2^0.5)^2; % ѧϰʣЭ
    cs = 4/(N + 4); damp = (1 - min(0.7, N * lambda/maxeval)) / cs + 1; %sigma˥

    % Initialize dynamic strategy parameters and constants
    B = eye(N); %ϵ
    D = eye(N); %ԽǾ
    BD = B * D; C = BD * transpose(BD); % CʾЭ
    pc = zeros(N, 1); ps = zeros(N, 1); % ֱΪ Э C   sigma Ľ·
    cw = sum(arweights) / norm(arweights); % Ϊ˼ЭĽ·һм
    chiN = N^0.5 * (1 - 1/(4 * N) + 1/(21 * N^2)); %  of ||N(0,I)|| == norm(randn(N,1))
    % Generation loop
    %     disp(['  (' num2str(mu) ', ' num2str(lambda) ')-CMA-ES (w = [' num2str(arweights', '%5.2f') '])' ]);
    counteval = 0; flgstop = 0;

    % Boundary
    LB = (ones(lambda, 1) * LB)';
    UB = (ones(lambda, 1) * UB)';

    while 1 % if flgstop break;

        % Set stop flag
        if counteval >= maxeval
            flgstop = 1;
        end 

        if flgstop
            break;
        end

        % Generate and evaluate lambda offspring
        arz = randn(N, lambda); % arzӾֵΪ0λЭ󹹳ɵĶԪֲ̬
        arx = xmeanw * ones(1, lambda) + sigma * (BD * arz); % ӶԪֲ̬m+sig *N(0,C)в˸

        % You may handle constraints here and now.
        % You may either resample columns of arz and/or multiply
        % them with a factor < 1 (the latter will result in a
        % decreased overall step size) and recalculate arx
        % accordingly. Do not change arx or arz in any other
        % way. You may also use an altered arx only for the
        % evaluation of the fitness function, if you leave
        % arx and arz unchanged for the algorithm.

            % Handle the elements of the variable which violate the boundary
        I = find(arx > UB);
        arx(I) = 2 * UB(I) - arx(I);
        aa = find(arx(I) < LB(I));
        arx(I(aa)) = LB(I(aa));
        I = find(arx < LB);
        arx(I) = 2 * LB(I) - arx(I);
        aa = find(arx(I) > UB(I));
        arx(I(aa)) = UB(I(aa));

        U = arx';
        for num = 1: lambda
            arfitness(num,:) = TestFunction(index,U(num,:)); % ۺ
        end
        counteval = counteval + lambda; %¼۴
        OFV = [OFV;arfitness];
        % Sort by fitness and compute weighted mean in xmeanw
        [arfitness, arindex] = sort(arfitness); % minimization
        xold = xmeanw; % for speed up of Eq. (14)
        xmeanw = arx(:, arindex(1:mu)) * arweights/sum(arweights); % Ȩµľֵ
        zmeanw = arz(:, arindex(1:mu)) * arweights/sum(arweights); % һм

        % Adapt covariance matrix
        pc = (1-cc) * pc + (sqrt(cc * (2-cc)) * cw/sigma) * (xmeanw-xold); % ЭĽ·
        if ~flginiphase % do not adapt in the initial phase
            C = (1-ccov) * C + ccov * pc * transpose(pc); % rank-1 Э²
        end

        % adapt sigma
        ps = (1-cs) * ps + (sqrt(cs * (2-cs)) * cw) * (B * zmeanw);      % sigmaĽ·
        sigma = sigma * exp((norm(ps)-chiN)/chiN/damp);     

        % Update B and D from C
        if mod(counteval/lambda, 1/ccov/N/5) < 1 
            C = triu(C) + transpose(triu(C, 1)); % enforce symmetry
            [B, D] = eig(C);
            % limit condition of C to 1e14 + 1
            if max(diag(D)) > 1e14 * min(diag(D))
                tmp = max(diag(D))/1e14 - min(diag(D));
                C = C + tmp * eye(N); D = D + tmp * eye(N);
            end
            D = diag(sqrt(diag(D))); % D contains standard deviations now
            BD = B * D; % for speed up only
        end % if mod

        % Adjust minimal step size
        if sigma * min(diag(D)) < minsigma ...
                | arfitness(1) == arfitness(min(mu + 1, lambda)) ...
                | xmeanw == xmeanw ...
                + 0.2 * sigma * BD(:, 1 + floor(mod(counteval/lambda, N)))
            sigma = 1.4 * sigma;

            % flgstop = 1;
        end
        if sigma > maxsigma
            sigma = maxsigma;
        end

        % Test for end of initial phase
        if flginiphase && counteval/lambda > 2/cs
            if (norm(ps)-chiN)/chiN < 0.05 % step size is not much too small
                flginiphase = 0;
            end
        end

    end % while, end generation loop

    %     disp([num2str(counteval) ': ' num2str(arfitness(1))]);
    %     if exist('sfile', 'var')
    %       disp(['Results saved in ' sfile]);
    %     end

    bestP = arx(:, arindex(1)); % return best point of last generation
    optValue = [optValue arfitness(1)];
    endNFEs = counteval;
end



